/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */

package mvcgrafik.controller;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import mvcgrafik.controller.commands.CommandInvoker;
import mvcgrafik.controller.commands.OpenCommand;
import mvcgrafik.controller.commands.SaveCommand;
import mvcgrafik.model.GrafikModel;
import mvcgrafik.view.GrafikFrame;

/**
 *
 * @author ahren
 */
public class CommandController implements ActionListener
{
  private GrafikFrame view;
  private GrafikModel model;
  private CommandInvoker invoker;
    
  public CommandController(GrafikFrame view, GrafikModel model)
  {
    this.view = view;
    this.model = model;
    this.invoker = new CommandInvoker();
  }

  public void registerEvents()
  {
    view.getBtnFileOpen().addActionListener(this);
    view.getBtnFileSave().addActionListener(this);
  }
  
  public void registerCommands()
  {
    invoker.addCommand(view.getBtnFileOpen(), new OpenCommand(view, model));
    invoker.addCommand(view.getBtnFileSave(), new SaveCommand(view,model));  
  }
  
    /**
     * Ausführen des jeweiligen Kommandos
     * @param e Referenz auf das Event
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        Component key = (Component)e.getSource();
        invoker.executeCommand(key);
        if(key == view.getBtnFileOpen()){
          invoker.deleteStack();
        }
    }
}
